#!/bin/bash

if [ $# -lt 1 ]; then
  echo "Usage: sofa-shut.sh component-id]"
  exit 1
fi

PRG="$0"

PRGDIR=`dirname "$PRG"`

SOFA_HOME=$PRGDIR/..

if [ -r "$PRGDIR"/setenv-auto.sh ]; then
  . "$PRGDIR"/setenv-auto.sh
fi

SOFACLASSPATH="$SOFA_HOME/lib/sofa2.jar"

java -cp $SOFACLASSPATH -Djava.security.policy="$SOFA_HOME/.java.policy" -Dsofa.logdir="$SOFALOGDIR" -Dlog4j.configuration="file:$SHUTLOGCONF" -Dsofa.agent.repository.context="$SOFAREPCONTEXT" org.objectweb.dsrg.sofa.deployment.launcher.Launcher -S "$ZEROCONFPORT" org.objectweb.dsrg.sofa.deployment.util.ShutdownApplication $*
