#!/bin/bash

if [ $# -ne 1 -a $# -ne 2 ]; then
        echo "Usage: sofa-dockosgi.sh name-of-the-dock [osgi-property-file]"
  exit 1
fi

PRG="$0"

PRGDIR=`dirname "$PRG"`

SOFA_HOME=$PRGDIR/..

if [ -r "$PRGDIR"/setenv.sh ]; then
  . "$PRGDIR"/setenv.sh
fi

SOFACLASSPATH="$SOFA_HOME/lib/sofa2.jar"

if [ ! -z "$2" ]; then
        FELIXCONF="$2"
fi

# DEBUG
DEBUG_ENABLED=false
if [ "$DEBUG_ENABLED" == "true" ]; then
  DEBUG="-Xdebug -Xrunjdwp:transport=dt_socket,address=8456,server=y,suspend=n"
else
  DEBUG=
fi
# end of debug

java -cp $SOFACLASSPATH -Djava.security.policy="$SOFA_HOME/.java.policy" -Dsofa.logdir="$SOFALOGDIR" -Dsofa.logfile="dock-${1}.log" -Dlog4j.configuration="file:$DOCKLOGCONF" -Dsofa.registry.port="$SOFARMIPORT" -Dsofa.registry.host="$SOFARMIHOST" -Djava.rmi.server.hostname="$SOFARMIHOST" -Dconnector.gcm.rmihost="$SOFACONMANHOST" -Dsofa.agent.repository.hostname="$SOFAREPHOST" -Dsofa.agent.repository.port="$SOFAREPPORT" -Dsofa.agent.repository.context="$SOFAREPCONTEXT" -Dosgi.bundles="$BUNDLES" -Dfelix.cache.profiledir="$FELIXCACHE" -Dfelix.config.properties="file:$FELIXCONF" -Dsofa.dock.capabilities=OSGi $DEBUG org.objectweb.dsrg.sofa.deployment.util.RunDeploymentDock $1
