#!/bin/bash

if [ $# -lt 2 ]; then
  echo "Usage: sofa-launch.sh name-of-app tag-of-app"
  echo "       sofa-launch.sh name-of-app -v version-of-app"
  exit 1
fi

PRG="$0"

PRGDIR=`dirname "$PRG"`

SOFA_HOME=$PRGDIR/..

if [ -r "$PRGDIR"/setenv.sh ]; then
  . "$PRGDIR"/setenv.sh
fi

SOFACLASSPATH="$SOFA_HOME/lib/sofa2.jar"

java -cp $SOFACLASSPATH -Djava.security.policy="$SOFA_HOME/.java.policy" -Dsofa.logdir="$SOFALOGDIR" -Dlog4j.configuration="file:$LAUNCHLOGCONF" -Dsofa.registry.port="$SOFARMIPORT" -Dsofa.registry.host="$SOFARMIHOST" -Dconnector.gcm.rmihost="$SOFACONMANHOST" -Dsofa.agent.repository.hostname="$SOFAREPHOST" -Dsofa.agent.repository.port="$SOFAREPPORT" -Dsofa.agent.repository.context="$SOFAREPCONTEXT" org.objectweb.dsrg.sofa.deployment.util.LaunchApplication $*
