package generated.A0000000K;

/**
 * Default primitive connector element implementation.
 */
public final class MessagingSendAdaptor
    implements
        org.objectweb.dsrg.connector.ElementLocalServer,
        org.objectweb.dsrg.connector.ElementLocalClient,
        org.objectweb.dsrg.connector.ReconfigurableElement,
        org.objectweb.dsrg.sofa.examples.messaging.iface.NewsPublisher {

    /**
     * Local target of business method invocations.
     */
    protected org.objectweb.dsrg.connector.messaging.MessageSender target;

    /**
     * Instance of dock connector manager which is responsible for connector
     * units within the dock.
     */
    protected org.objectweb.dsrg.connector.mgr.DockConnectorManager dcm;

    /**
     * Reference to parent connector unit.
     */
    protected org.objectweb.dsrg.connector.ConnectorUnit parentUnit;

    protected boolean isTopLevel;

    /**
     * Reconfiguration request handler.
     */
    protected org.objectweb.dsrg.connector.ReconfigurationHandler reconfigurationHandler;


    /* **********************************************************************
     * CONSTRUCTORS
     * **********************************************************************/

    /**
     * Constructs a new primitive element.
     */
    public MessagingSendAdaptor (
            org.objectweb.dsrg.connector.ConnectorUnit parentUnit,
            boolean isTopLevel) {

        this.parentUnit = parentUnit;
        this.isTopLevel = isTopLevel;

        this.dcm = org.objectweb.dsrg.connector.mgr.
            DockConnectorManagerHelper.getDockConnectorManager ();
    }


    /* **********************************************************************
     * Element Methods
     * **********************************************************************/

	public final String getElementInfo (String indent) {
		StringBuilder result = new StringBuilder ();

		result.append (indent +"Implementation: \"messaging_send_adaptor\"\n");

		return result.toString ();
	}


    /**
     * Sets the reconfiguration handler.
     */
    public final void setElReconfigurationHandler (
        org.objectweb.dsrg.connector.ReconfigurationHandler reconfigurationHandler) {

        this.reconfigurationHandler = reconfigurationHandler;
    }


    /* **********************************************************************
     * ElementLocalClient Methods
     * **********************************************************************/

    /**
     * Binds a given required port of this element to a target object using
     * a local object reference.
     *
     * TODO: Handle reconfiguration.
     */
    public void bindElPort (String portName, Object target)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("out".equals (portName)) {
            this.target = (org.objectweb.dsrg.connector.messaging.MessageSender) target;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to bind non-existent required port '"+ portName +"'.");
        }
    }


    /**
     * Unbinds a given required port of this element from its target.
     *
     * TODO: Handle reconfiguration.
     */
    public void unbindElPort (String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("out".equals (portName)) {
            this.target = null;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to unbind non-existent required port '"+ portName +"'.");
        }
    }


    /* **********************************************************************
     * ElementLocalServer Methods
     * **********************************************************************/

    /**
     * Queries given provided port for a local object reference.
     */
    public Object lookupElPort (String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("in".equals (portName)) {
            if (isTopLevel) {
                dcm.reregisterConnectorUnitReference (parentUnit, "in", this);
            }

            return this;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to look up non-existent provided port '"+ portName +"'.");
        }
    }


    /* **********************************************************************
     * org.objectweb.dsrg.connector.messaging.MessageSender Methods
     * **********************************************************************/

	public void publish (java.util.ArrayList arg0) {
this.target.send(arg0);		return;
	}


}
