package generated.A0000000N;

import org.apache.activemq.broker.BrokerService;

public final class MessagingDistributorUnit 
	implements
		org.objectweb.dsrg.connector.ElementLocalServer,
	    org.objectweb.dsrg.connector.ElementRemoteServer,
	    iface.DummyBusIface {

    /**
     * Instance of dock connector manager which is responsible for connector
     * units within the dock.
     */
    protected org.objectweb.dsrg.connector.mgr.DockConnectorManager dcm;

    protected org.objectweb.dsrg.connector.mgr.GlobalConnectorManager gcm;

    /**
     * Reference to parent connector unit.
     */
    protected org.objectweb.dsrg.connector.ConnectorUnit parentUnit;

    protected boolean isTopLevel;

    protected String topic = "ahoj";


    /* **********************************************************************
     * CONSTRUCTORS
     * **********************************************************************/

    public MessagingDistributorUnit (
            org.objectweb.dsrg.connector.ConnectorUnit parentUnit,
            boolean isTopLevel)
        throws
            java.rmi.RemoteException, java.net.MalformedURLException,
            org.objectweb.dsrg.connector.ElementLinkException,
            org.objectweb.dsrg.connector.mgr.ConnectorManagerException,
            Exception {

        this.parentUnit = parentUnit;
        this.isTopLevel = isTopLevel;

        dcm = org.objectweb.dsrg.connector.mgr.
            DockConnectorManagerHelper.getDockConnectorManager ();
        gcm = org.objectweb.dsrg.connector.mgr.
            GlobalConnectorManagerHelper.getGlobalConnectorManager ();
            
        BrokerService broker = new BrokerService();
        broker.setUseJmx(true);
        broker.addConnector("tcp://localhost:61616");
        broker.start();
    }


    /* **********************************************************************
     * Element Methods
     * **********************************************************************/

	public final String getElementInfo (String indent) { return ""; }


	/* **********************************************************************
     * ElementLocalServer Methods
     * **********************************************************************/

    public Object lookupElPort (String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

		if ("call".equals (portName)) {
	        if (isTopLevel) {
	            dcm.reregisterConnectorUnitReference (parentUnit, "call", this);
	        }
	
	        return this;
	
	    } else {
	        throw new org.objectweb.dsrg.connector.ElementLinkException (
	            "Attempt to look up non-existent provided port '"+ portName +"'.");
	    }
    }

    /* **********************************************************************
     * ElementRemoteServer Methods
     * **********************************************************************/

    public org.objectweb.dsrg.connector.RemoteRefBundle lookupElRemotePort (
            String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        org.objectweb.dsrg.connector.RemoteRefBundle result =
            new org.objectweb.dsrg.connector.RemoteRefBundle ();

        if ("line".equals (portName)) {
            result.addRef (
                new org.objectweb.dsrg.connector.RemoteRef ("messaging", topic));

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to look up non-existent remote port '"+ portName +"'.");
        }

        return result;
    }


    /**
     * Returns the names of remote ports supported by this element.
     */
    public String [] listElRemotePorts () {
        return new String [] { "line" };
    }
}
