/* $Id: StreamProvider.java 278 2008-08-15 18:17:30Z mmalohlava $
 *
 * SOFA 2.0 component system
 * Copyright (C) 2006-2008  DSRG, Charles University in Prague
 *                          http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.objectweb.dsrg.connector.streaming;

import java.io.InputStream;

/**
 * Stream provider interface.
 * 
 * Copy from congen.jar.
 * 
 * @author Michal Malohlava
 *
 */
public interface StreamProvider {
	/**
	 * Get a stream with given id.
	 * 
	 * All the time the methods returns not-null reference to the requested stream.
	 * If the stream with given id is not found, then the method returns empty stream.
	 * 
	 * @param id stream identification e.g. file name
	 * 
	 * @return input stream, client has to handle synchronous access to this stream, also closing the stream.  
	 */
	InputStream getStream(String id);
}
