package org.objectweb.dsrg.sofa.examples.logdemo.arch;

import org.objectweb.dsrg.sofa.examples.logdemo.iface.Log;
import org.objectweb.dsrg.sofa.annotations.*;
import java.util.Map;

@Updatable
public class AnnotatedLogger {
  private LoggerImpl impl = new LoggerImpl ();
  private int counter = 0;

  class LoggerImpl implements Log {
    public void log( String message )
    {
      System.out.println("LoggerImpl [" + ++counter + "]: " + message);
    }
  }
  
  @Provided(name="log")
  public Object provideLog () { return impl; }
  
  @SavesState
  public void saveCounter (Map m)
  {
    m.put ("counter", new Integer (counter));
  }

  @LoadsState
  public void loadCounter (Map m)
  {
    Object o = m.get ("counter");
    counter = ((Integer) o).intValue ();
  }
}
