package org.objectweb.dsrg.sofa.examples.messaging.arch;

import java.util.ArrayList;
import java.util.Random;

import org.objectweb.dsrg.sofa.SOFAClient;
import org.objectweb.dsrg.sofa.SOFALifecycle;
import org.objectweb.dsrg.sofa.examples.messaging.iface.NewsPublisher;

public class Producer implements SOFAClient, Runnable, SOFALifecycle {
	
	private static final int MAX_NUM_NEWS = 10;
	
	private NewsPublisher publisher;
	private boolean end = false;
	
	private Random randomizer = new Random();

	@Override
	public void setRequired(String name, Object iface) {		
		if ("produce-iface".equals(name)) {
			if (iface instanceof NewsPublisher) {
				publisher = (NewsPublisher) iface;
			}
		}
	}

	@Override
	public void run() {
		while (!end) {			
			this.publisher.publish(getNews());
			
			try {
				Thread.sleep(5000);
			} catch (Exception _) {};
			
		}
		
	}
	
	protected ArrayList<String> getNews() {
		int numOfNews = randomizer.nextInt(MAX_NUM_NEWS) + 1;
		
		ArrayList<String> list = new java.util.ArrayList<String>();
		
		System.out.println("Produce: producing list of messages");
		for (int i = 0; i < numOfNews; i++) {
			String s = "News n. " + i;
			list.add(s);
			System.out.println(s);
		}						
		System.out.println("-- end of list --");
		
		return list;
	}

	@Override
	public void start() {
		Thread  t = new Thread(this);
		
		t.start();		
	}

	@Override
	public void stop() {
		end = true;
	}

	@Override
	public void stopping() {
		// TODO Auto-generated method stub
		
	}
}